<?php
namespace Accounts\Admin\Controller;

use Accounts\Admin\Controller\AppController;
use Cake\Event\Event;

/**
 * Users Controller
 *
 * @property \Accounts\Admin\Model\Table\UsersTable $Users
 *
 * @method \Accounts\Admin\Model\Entity\User[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class UsersController extends AppController
{

    public $paginate = [
        'limit' => 20
    ];

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->loadComponent('Search.Prg', [
            'actions' => ['index']
        ]);
    }

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);
        $this->viewBuilder()->setHelpers(['Materialize.Form']);
    }
    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $this->paginate = [
            'contain' => ['Roles']
        ];

        $users = $this->Users
            ->find('search', ['search' => $this->request->getQueryParams()]);

        $users = $this->paginate($users);

        $this->set(compact('users'));
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function edit($id)
    {
        $user = $this->Users->get($id);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $user = $this->Users->patchEntity($user, $this->request->getData());
            if ($this->Users->save($user)) {
                $this->Flash->success(__d('Accounts/admin', 'The user has been updated.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__d('Accounts/admin', 'The user could not be updated. Please, try again.'));
        }
        $roles = $this->Users->Roles->find('list', [
            'keyField' => 'id',
            'valueField' => 'name'
        ]);
        $this->set(compact('user', 'roles'));
    }
}
